/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#ifndef TEST_REMOTEFILEREP_H
#define TEST_REMOTEFILEREP_H

#include <Controller.h>
#include <cameo/cameo.h>

namespace test {

class RemoteFileRep : public ExperimentController,
						public controller::Stoppable {

public:
	//! Type of controller
	static const std::string TYPE;

	RemoteFileRep(const std::string& name);
	RemoteFileRep(const RemoteFileRep& controller);
	virtual ~RemoteFileRep();

	virtual void postConfiguration();

	virtual void start();
	virtual void stop();

	Property<std::string> serverEndpoint;
	Property<bool> initialized;
	Property<string> filename;

private:
	bool initApplication();
	void sendFile();

	static const std::string REMOTE_APPLICATION;
	static const std::string FILE_RESPONDER;

	std::auto_ptr<cameo::Server> m_server;
	std::auto_ptr<cameo::application::Instance> m_remoteApplication;
};

}

#endif
