/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#ifndef IN16_RUNSPECTRUMS_H
#define IN16_RUNSPECTRUMS_H

#include <Controller.h>
#include "FrequencyRemoteMatlabReq.h"

namespace in16 {

class RunSpectrums : public ExperimentController,
						public controller::Stoppable {

public:
	//! Type of controller
	static const std::string TYPE;

	RunSpectrums(const std::string& name);
	virtual ~RunSpectrums();

	virtual void postConfiguration();

	virtual void start();
	virtual void stop();

	Property<double> fr;
	Property<double> frMin;
	Property<double> frMax;
	Property<int32> nMax;
	Property<double> time;
	Property<std::string> comment;

	ControllerPtr<FrequencyRemoteMatlabReq> matlabController;
};

}

#endif
