/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#include "RunSpectrumsTest.h"
#include "controllers/common/family/Families.h"

namespace in16 {

using namespace std;
using namespace common;

const std::string RunSpectrumsTest::TYPE = "in16_run_spectrums_test";

RunSpectrumsTest::RunSpectrumsTest(const std::string& name) :
	RunSpectrums(name) {

	frMin = 1E1;
	frMax = 1E6;
	nMax = 5;
	comment = "a comment";
}

RunSpectrumsTest::~RunSpectrumsTest() {
}

void RunSpectrumsTest::start() {

	matlabController->requestType = FrequencyRemoteMatlabReq::RUN_SPECTRUMS_TEST;
	matlabController->frMin = frMin();
	matlabController->frMax = frMax();
	matlabController->nMax = nMax();
	matlabController->comment = comment();

	matlabController->startCommand();
}

}
