/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#ifndef TAS_REMOTEMATLABREQ_H
#define TAS_REMOTEMATLABREQ_H

#include "RemoteMatlab.h"

namespace tas {

class RemoteMatlabReq : public RemoteMatlab {

public:
	//! Type of controller
	static const std::string TYPE;

	RemoteMatlabReq(const std::string& name);
	RemoteMatlabReq(const RemoteMatlabReq& controller);
	virtual ~RemoteMatlabReq();

	virtual void postConfiguration();

	void updateNumor();
	void updateCountStatusMessage();

	virtual void start();

private:
	bool initApplication();
	void sendNumor(int32 numor, bool live);
	void sendImageToFluentd(const proto::NumorResponse& response);

	static const std::string MATLAB_APPLICATION;
	static const std::string NUMOR_RESPONDER;
	static const int32 LOG_TYPE;
	static const int32 LIVE_TYPE;

	std::auto_ptr<cameo::Server> m_server;
	std::auto_ptr<cameo::application::Instance> m_matlabApplication;
	std::auto_ptr<cameo::application::Requester> m_requester;
};

}

#endif
